'use strict';

exports.__esModule = true;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _fixture = require('./fixture');

var _fixture2 = _interopRequireDefault(_fixture);

var _test = require('./test');

var _test2 = _interopRequireDefault(_test);

var _handleTagArgs = require('../../utils/handle-tag-args');

var _handleTagArgs2 = _interopRequireDefault(_handleTagArgs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Globals = function () {
    function Globals(filename) {
        (0, _classCallCheck3.default)(this, Globals);

        this.filename = filename;
        this.currentFixture = null;
        this.collectedTests = [];

        var globals = this;

        // NOTE: use named functions so that they appear in the stacks
        this.functions = {
            fixture: function fixture(name) {
                for (var _len = arguments.length, rest = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                    rest[_key - 1] = arguments[_key];
                }

                name = (0, _handleTagArgs2.default)(name, rest);

                globals.currentFixture = new _fixture2.default(name, globals.filename);

                return globals.currentFixture;
            },
            test: function test(name, fn) {
                var test = new _test2.default(name, fn, globals.currentFixture);

                globals.collectedTests.push(test);
            }
        };
    }

    Globals.prototype.setup = function setup() {
        var _this = this;

        (0, _keys2.default)(this.functions).forEach(function (name) {
            global[name] = _this.functions[name];
        });
    };

    Globals.prototype.remove = function remove() {
        (0, _keys2.default)(this.functions).forEach(function (name) {
            return delete global[name];
        });
    };

    return Globals;
}();

exports.default = Globals;
module.exports = exports['default'];