'use strict';

exports.__esModule = true;
exports.default = buildDiff;

var _array = require('./array');

var _array2 = _interopRequireDefault(_array);

var _object = require('./object');

var _object2 = _interopRequireDefault(_object);

var _string = require('./string');

var _string2 = _interopRequireDefault(_string);

var _date = require('./date');

var _date2 = _interopRequireDefault(_date);

var _truncateDiff = require('./truncate-diff');

var _truncateDiff2 = _interopRequireDefault(_truncateDiff);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function buildDiff(err, maxStringLength) {
    if (err.isArrays) return (0, _array2.default)(err, maxStringLength);
    if (err.isObjects) return (0, _object2.default)(err, maxStringLength);
    if (err.isStrings) return (0, _string2.default)(err, maxStringLength);
    if (err.isDates) return (0, _date2.default)(err);

    return (0, _truncateDiff2.default)(err, maxStringLength);
}
module.exports = exports['default'];