'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _highlightEs = require('highlight-es');

var _highlightEs2 = _interopRequireDefault(_highlightEs);

var _formattableAdapter = require('../../errors/test-run/formattable-adapter');

var _formattableAdapter2 = _interopRequireDefault(_formattableAdapter);

var _templates = require('./templates');

var _templates2 = _interopRequireDefault(_templates);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;

var renderer = ['string', 'punctuator', 'keyword', 'number', 'regex', 'comment', 'invalid'].reduce(function (syntaxRenderer, tokenType) {
    syntaxRenderer[tokenType] = function (str) {
        return '<span class="syntax-' + tokenType + '">' + (0, _lodash.escape)(str) + '</span>';
    };

    return syntaxRenderer;
}, {});

var LegacyTestRunErrorFormattableAdapter = function (_TestRunErrorFormatta) {
    (0, _inherits3.default)(LegacyTestRunErrorFormattableAdapter, _TestRunErrorFormatta);

    function LegacyTestRunErrorFormattableAdapter(err, metaInfo) {
        (0, _classCallCheck3.default)(this, LegacyTestRunErrorFormattableAdapter);

        var _this = (0, _possibleConstructorReturn3.default)(this, _TestRunErrorFormatta.call(this, err, metaInfo));

        _this.TEMPLATES = _templates2.default;
        return _this;
    }

    LegacyTestRunErrorFormattableAdapter.prototype.getCallsiteMarkup = function getCallsiteMarkup() {
        var code = (0, _highlightEs2.default)(this.callsite, renderer);
        var lines = code.split(NEWLINE);
        var lastLine = lines.pop();

        lastLine = '<div class="code-line-last">' + lastLine + '</div>';
        lines = lines.map(function (line) {
            return '<div class="code-line"><div class="code-line-src">' + line + '</div></div>';
        });

        return '<div class="code-frame">' + lines.join('') + lastLine + '</div>';
    };

    return LegacyTestRunErrorFormattableAdapter;
}(_formattableAdapter2.default);

exports.default = LegacyTestRunErrorFormattableAdapter;
module.exports = exports['default'];